diff --git a/libglusterfs/src/glusterfs/syscall.h b/libglusterfs/src/glusterfs/syscall.h
index b6d3ab4f2ad..2c763f7c0a7 100644
--- a/libglusterfs/src/glusterfs/syscall.h
+++ b/libglusterfs/src/glusterfs/syscall.h
@@ -122,6 +122,9 @@ sys_chmod(const char *path, mode_t mode);
 int
 sys_fchmod(int fd, mode_t mode);
 
+int
+sys_lchmod(const char *path, mode_t mode);
+
 int
 sys_chown(const char *path, uid_t owner, gid_t group);
 
diff --git a/libglusterfs/src/libglusterfs.sym b/libglusterfs/src/libglusterfs.sym
index 179d3458e4b..87af51ea081 100644
--- a/libglusterfs/src/libglusterfs.sym
+++ b/libglusterfs/src/libglusterfs.sym
@@ -1046,6 +1046,7 @@ sys_fstatat
 sys_fsync
 sys_ftruncate
 sys_futimes
+sys_lchmod
 sys_lchown
 sys_lgetxattr
 sys_link
diff --git a/libglusterfs/src/syscall.c b/libglusterfs/src/syscall.c
index 04400f98b6c..98bbb5c9c06 100644
--- a/libglusterfs/src/syscall.c
+++ b/libglusterfs/src/syscall.c
@@ -289,6 +289,12 @@ sys_fchmod(int fd, mode_t mode)
     return FS_RET_CHECK0(fchmod(fd, mode), errno);
 }
 
+int
+sys_lchmod(const char *path, mode_t mode)
+{
+    return FS_RET_CHECK0(lchmod(path, mode), errno);
+}
+
 int
 sys_chown(const char *path, uid_t owner, gid_t group)
 {
diff --git a/xlators/storage/posix/src/posix-inode-fd-ops.c b/xlators/storage/posix/src/posix-inode-fd-ops.c
index 3f51c49642a..a90ab8dd6d8 100644
--- a/xlators/storage/posix/src/posix-inode-fd-ops.c
+++ b/xlators/storage/posix/src/posix-inode-fd-ops.c
@@ -251,8 +251,13 @@ posix_do_chmod(xlator_t *this, const char *path, struct iatt *stbuf)
         mode_bit = (mode & priv->create_mask) | priv->force_create_mode;
         mode = posix_override_umask(mode, mode_bit);
     }
-    ret = lchmod(path, mode);
-    if ((ret == -1) && (errno == ENOSYS)) {
+    ret = sys_lchmod(path, mode);
+    /* Before glibc 2.32, lchmod() was not implemented and calling it
+     * always returned ENOSYS. Starting with glibc 2.32 this request
+     * is using fchmodat() system call to implement it. However, linux
+     * doesn't support setting the mode for symlinks, so the system
+     * call returns ENOTSUPP. We need to handle both cases. */
+    if ((ret < 0) && ((errno == ENOSYS) || (errno == ENOTSUPP))) {
         /* in Linux symlinks are always in mode 0777 and no
            such call as lchmod exists.
         */
